Index: src/tesselationhelpers.cpp
===================================================================
--- src/tesselationhelpers.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/tesselationhelpers.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -889,17 +927,18 @@
 bool CheckListOfBaselines(const Tesselation * const TesselStruct)
 {
+	Info FunctionInfo(__func__);
   LineMap::const_iterator testline;
   bool result = false;
   int counter = 0;
 
-  Log() << Verbose(1) << "Check: List of Baselines with not two connected triangles:" << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Check: List of Baselines with not two connected triangles:" << endl);
   for (testline = TesselStruct->LinesOnBoundary.begin(); testline != TesselStruct->LinesOnBoundary.end(); testline++) {
     if (testline->second->triangles.size() != 2) {
-      Log() << Verbose(1) << *testline->second << "\t" << testline->second->triangles.size() << endl;
+      DoLog(2) && (Log() << Verbose(2) << *testline->second << "\t" << testline->second->triangles.size() << endl);
       counter++;
     }
   }
   if (counter == 0) {
-    Log() << Verbose(1) << "None." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "None." << endl);
     result = true;
   }
@@ -907,2 +946,91 @@
 }
 
+/** Counts the number of triangle pairs that contain the given polygon.
+ * \param *P polygon with endpoints to look for
+ * \param *T set of triangles to create pairs from containing \a *P
+ */
+int CountTrianglePairContainingPolygon(const BoundaryPolygonSet * const P, const TriangleSet * const T)
+{
+  Info FunctionInfo(__func__);
+  // check number of endpoints in *P
+  if (P->endpoints.size() != 4) {
+    DoeLog(1) && (eLog()<< Verbose(1) << "CountTrianglePairContainingPolygon works only on polygons with 4 nodes!" << endl);
+    return 0;
+  }
+
+  // check number of triangles in *T
+  if (T->size() < 2) {
+    DoeLog(1) && (eLog()<< Verbose(1) << "Not enough triangles to have pairs!" << endl);
+    return 0;
+  }
+
+  DoLog(0) && (Log() << Verbose(0) << "Polygon is " << *P << endl);
+  // create each pair, get the endpoints and check whether *P is contained.
+  int counter = 0;
+  PointSet Trianglenodes;
+  class BoundaryPolygonSet PairTrianglenodes;
+  for(TriangleSet::iterator Walker = T->begin(); Walker != T->end(); Walker++) {
+    for (int i=0;i<3;i++)
+      Trianglenodes.insert((*Walker)->endpoints[i]);
+
+    for(TriangleSet::iterator PairWalker = Walker; PairWalker != T->end(); PairWalker++) {
+      if (Walker != PairWalker) { // skip first
+        PairTrianglenodes.endpoints = Trianglenodes;
+        for (int i=0;i<3;i++)
+          PairTrianglenodes.endpoints.insert((*PairWalker)->endpoints[i]);
+        const int size = PairTrianglenodes.endpoints.size();
+        if (size == 4) {
+          DoLog(0) && (Log() << Verbose(0) << " Current pair of triangles: " << **Walker << "," << **PairWalker << " with " << size << " distinct endpoints:" << PairTrianglenodes << endl);
+          // now check
+          if (PairTrianglenodes.ContainsPresentTupel(P)) {
+            counter++;
+            DoLog(0) && (Log() << Verbose(0) << "  ACCEPT: Matches with " << *P << endl);
+          } else {
+            DoLog(0) && (Log() << Verbose(0) << "  REJECT: No match with " << *P << endl);
+          }
+        } else {
+          DoLog(0) && (Log() << Verbose(0) << "  REJECT: Less than four endpoints." << endl);
+        }
+      }
+    }
+    Trianglenodes.clear();
+  }
+  return counter;
+};
+
+/** Checks whether two give polygons have two or more points in common.
+ * \param *P1 first polygon
+ * \param *P2 second polygon
+ * \return true - are connected, false = are note
+ */
+bool ArePolygonsEdgeConnected(const BoundaryPolygonSet * const P1, const BoundaryPolygonSet * const P2)
+{
+  Info FunctionInfo(__func__);
+  int counter = 0;
+  for(PointSet::const_iterator Runner = P1->endpoints.begin(); Runner != P1->endpoints.end(); Runner++) {
+    if (P2->ContainsBoundaryPoint((*Runner))) {
+      counter++;
+      DoLog(1) && (Log() << Verbose(1) << *(*Runner) << " of second polygon is found in the first one." << endl);
+      return true;
+    }
+  }
+  return false;
+};
+
+/** Combines second into the first and deletes the second.
+ * \param *P1 first polygon, contains all nodes on return
+ * \param *&P2 second polygon, is deleted.
+ */
+void CombinePolygons(BoundaryPolygonSet * const P1, BoundaryPolygonSet * &P2)
+{
+  Info FunctionInfo(__func__);
+  pair <PointSet::iterator, bool> Tester;
+  for(PointSet::iterator Runner = P2->endpoints.begin(); Runner != P2->endpoints.end(); Runner++) {
+    Tester = P1->endpoints.insert((*Runner));
+    if (Tester.second)
+      DoLog(0) && (Log() << Verbose(0) << "Inserting endpoint " << *(*Runner) << " into first polygon." << endl);
+  }
+  P2->endpoints.clear();
+  delete(P2);
+};
+
Index: src/tesselationhelpers.hpp
===================================================================
--- src/tesselationhelpers.hpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/tesselationhelpers.hpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -59,6 +59,6 @@
 bool CheckLineCriteriaForDegeneratedTriangle(const BoundaryPointSet * const nodes[3]);
 bool SortCandidates(const CandidateForTesselation* candidate1, const CandidateForTesselation *candidate2);
-TesselPoint* FindClosestPoint(const Vector* Point, TesselPoint *&SecondPoint, const LinkedCell* const LC);
-TesselPoint* FindSecondClosestPoint(const Vector*, const LinkedCell* const LC);
+TesselPoint* FindClosestTesselPoint(const Vector* Point, TesselPoint *&SecondPoint, const LinkedCell* const LC);
+TesselPoint* FindSecondClosestTesselPoint(const Vector*, const LinkedCell* const LC);
 Vector * GetClosestPointBetweenLine(const BoundaryLineSet * const Base, const BoundaryLineSet * const OtherBase);
 
@@ -72,4 +72,8 @@
 bool CheckListOfBaselines(const Tesselation * const TesselStruct);
 
+int CountTrianglePairContainingPolygon(const BoundaryPolygonSet * const P, const TriangleSet * const T);
+bool ArePolygonsEdgeConnected(const BoundaryPolygonSet * const P1, const BoundaryPolygonSet * const P2);
+void CombinePolygons(BoundaryPolygonSet * const P1, BoundaryPolygonSet * &P2);
+
 
 #endif /* TESSELATIONHELPERS_HPP_ */
Index: src/triangleintersectionlist.cpp
===================================================================
--- src/triangleintersectionlist.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
+++ src/triangleintersectionlist.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -0,0 +1,173 @@
+/*
+ * triangleintersectionlist.cpp
+ *
+ * This files encapsulates the TriangleIntersectionList class where all matters related to points in space being how close to
+ * a tesselated surface are answered, i.e. distance, is inside, ...
+ *
+ *  Created on: Mar 1, 2010
+ *      Author: heber
+ */
+
+#include "triangleintersectionlist.hpp"
+
+#include "info.hpp"
+#include "tesselation.hpp"
+#include "vector.hpp"
+
+/** Constructor for class TriangleIntersectionList.
+ *
+ */
+TriangleIntersectionList::TriangleIntersectionList(const Vector *x, const Tesselation *surface, const LinkedCell* LC) :
+  Point(x),
+  Tess(surface),
+  Vicinity(LC)
+{
+  Info FunctionInfo(__func__);
+  GatherIntersectionsWithTriangles();
+};
+
+/** Destructor for class TriangleIntersectionList.
+ * Free's all allocated intersection vectors
+ */
+TriangleIntersectionList::~TriangleIntersectionList()
+{
+  Info FunctionInfo(__func__);
+  for (TriangleVectorMap::iterator Runner = IntersectionList.begin(); Runner != IntersectionList.end(); Runner++)
+    delete((*Runner).second);
+};
+
+/** Returns the smallest distance between TriangleIntersectionList::Point and the surface given by
+ * TriangleIntersectionList::Tess.
+ * \return distance >=0, -1 if no specific distance could be found
+ */
+double TriangleIntersectionList::GetSmallestDistance() const
+{
+  Info FunctionInfo(__func__);
+  FillDistanceList();
+  if (!DistanceList.empty())
+    return DistanceList.begin()->first;
+  else
+    // return reference, if none can be found
+    return -1.;
+};
+
+/** Returns the vector of closest intersection between TriangleIntersectionList::Point and the surface
+ * TriangleIntersectionList::Tess.
+ * \return Intersection vector or TriangleIntersectionList::Point if none could be found
+ */
+Vector TriangleIntersectionList::GetClosestIntersection() const
+{
+  Info FunctionInfo(__func__);
+  TriangleVectorMap::const_iterator runner;
+  runner = GetIteratortoSmallestDistance();
+  if (runner != IntersectionList.end()) {
+    return *((*runner).second);
+  }
+  // return reference, if none can be found
+  return *Point;
+};
+
+/** Returns the triangle closest to TriangleIntersectionList::Point and the surface
+ * TriangleIntersectionList::Tess.
+ * \return pointer to triangle or NULL if none could be found
+ */
+BoundaryTriangleSet * TriangleIntersectionList::GetClosestTriangle() const
+{
+  Info FunctionInfo(__func__);
+  TriangleVectorMap::const_iterator runner;
+  runner = GetIteratortoSmallestDistance();
+  if (runner != IntersectionList.end()) {
+    return ((*runner).first);
+  }
+  // return reference, if none can be found
+  return NULL;
+};
+
+/** Checks whether reference TriangleIntersectionList::Point of this class is inside or outside.
+ * \return true - TriangleIntersectionList::Point is inside, false - is outside
+ */
+bool TriangleIntersectionList::IsInside() const
+{
+  Info FunctionInfo(__func__);
+  TriangleVectorMap::const_iterator runner;
+  runner = GetIteratortoSmallestDistance();
+  if (runner != IntersectionList.end()) {
+    // if we have found one, check Scalarproduct between the vector
+    Vector TestVector(Point);
+    TestVector.SubtractVector((*runner).second);
+    if (fabs(TestVector.NormSquared()) < MYEPSILON) //
+      return true;
+    const double sign = (*runner).first->NormalVector.ScalarProduct(&TestVector);
+    if (sign < 0) {
+      return true;
+    } else {
+      return false;
+    }
+  }
+  // so far away from surface that there are no triangles in list
+  return false;
+};
+
+/** Puts all triangles in vicinity (by \a *LC) into a hash map with Intersection vectors.
+ * Private function for constructor of TriangleIntersectionList.
+ */
+void TriangleIntersectionList::GatherIntersectionsWithTriangles()
+{
+  Info FunctionInfo(__func__);
+
+  // get closest points
+  DistanceToPointMap * points = Tess->FindClosestBoundaryPointsToVector(Point,Vicinity);
+  if (points == NULL) {
+    DoeLog(1) && (eLog()<< Verbose(1) << "There is no nearest point: too far away from the surface." << endl);
+    return;
+  }
+
+  // gather all triangles in *LC-neighbourhood
+  TriangleSet triangles;
+  for (DistanceToPointMap::iterator Runner = points->begin(); Runner != points->end(); Runner++)
+    for (LineMap::iterator LineRunner = Runner->second->lines.begin(); LineRunner != Runner->second->lines.end(); LineRunner++)
+      for (TriangleMap::iterator TriangleRunner = LineRunner->second->triangles.begin(); TriangleRunner != LineRunner->second->triangles.end(); TriangleRunner++)
+        triangles.insert(TriangleRunner->second);
+
+  Vector *Intersection = NULL;
+  for (TriangleSet::const_iterator TriangleRunner = triangles.begin(); TriangleRunner != triangles.end(); TriangleRunner++) {
+    // get intersection with triangle plane
+    Intersection = new Vector;
+    (*TriangleRunner)->GetClosestPointInsideTriangle(Point, Intersection);
+    //Log() << Verbose(1) << "Intersection between " << *Point << " and " << **TriangleRunner << " is at " << *Intersection << "." << endl;
+    IntersectionList.insert( pair<BoundaryTriangleSet *, Vector * > (*TriangleRunner, Intersection) );
+  }
+};
+
+/** Fills the private distance list
+ */
+void TriangleIntersectionList::FillDistanceList() const
+{
+  Info FunctionInfo(__func__);
+  if (DistanceList.empty())
+    for (TriangleVectorMap::const_iterator runner = IntersectionList.begin(); runner != IntersectionList.end(); runner++)
+      DistanceList.insert( pair<double, BoundaryTriangleSet *> (Point->Distance((*runner).second), (*runner).first) );
+
+  //for (DistanceTriangleMap::const_iterator runner = DistanceList.begin(); runner != DistanceList.end(); runner++)
+  //  Log() << Verbose(1) << (*runner).first << " away from " << *(*runner).second << endl;
+};
+
+
+/** Returns the iterator in VectorTriangleMap to the smallest distance.
+ * This is a private helper function as the iterator is then evaluated in some other functions.
+ * \return iterator or TriangleIntersectionList::IntersectionList.end() if none could be found
+ */
+TriangleVectorMap::const_iterator TriangleIntersectionList::GetIteratortoSmallestDistance() const
+{
+  Info FunctionInfo(__func__);
+  FillDistanceList();
+
+  // do we have any intersections?
+  TriangleVectorMap::const_iterator runner;
+  if (!DistanceList.empty()) {
+    // get closest triangle
+    runner = IntersectionList.find(DistanceList.begin()->second);
+  }
+  return runner;
+};
+
Index: src/triangleintersectionlist.hpp
===================================================================
--- src/triangleintersectionlist.hpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
+++ src/triangleintersectionlist.hpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -0,0 +1,61 @@
+/*
+ * TriangleIntersectionList.hpp
+ *
+ *  Created on: Mar 1, 2010
+ *      Author: heber
+ */
+
+#ifndef TRIANGLEINTERSECTIONLIST_HPP_
+#define TRIANGLEINTERSECTIONLIST_HPP_
+
+using namespace std;
+
+/*********************************************** includes ***********************************/
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <map>
+
+/****************************************** forward declarations *****************************/
+
+class BoundaryTriangleSet;
+class LinkedCell;
+class Tesselation;
+class Vector;
+
+/********************************************** definitions *********************************/
+
+#define TriangleVectorMap map < class BoundaryTriangleSet *, Vector *>
+#define DistanceTriangleMap map < double, class BoundaryTriangleSet *>
+
+// ======================================================== class TriangleIntersectionList =======================================
+
+/** Stores all intersection vectors to a list of triangles.
+ */
+class TriangleIntersectionList
+{
+public:
+  TriangleIntersectionList(const Vector *x, const Tesselation *surface, const LinkedCell* LC);
+  ~TriangleIntersectionList();
+
+  double GetSmallestDistance() const;
+  Vector GetClosestIntersection() const;
+  BoundaryTriangleSet * GetClosestTriangle() const;
+  bool IsInside() const;
+
+private:
+  void GatherIntersectionsWithTriangles();
+  TriangleVectorMap::const_iterator GetIteratortoSmallestDistance() const;
+  void FillDistanceList() const;
+
+  const Vector *Point;
+  const Tesselation *Tess;
+  const LinkedCell *Vicinity;
+  TriangleVectorMap IntersectionList;
+  mutable DistanceTriangleMap DistanceList;
+};
+
+#endif /* TRIANGLEINTERSECTIONLIST_HPP_ */
Index: src/unittests/AnalysisCorrelationToPointUnitTest.cpp
===================================================================
--- src/unittests/AnalysisCorrelationToPointUnitTest.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/unittests/AnalysisCorrelationToPointUnitTest.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -11,4 +11,6 @@
 #include <cppunit/extensions/TestFactoryRegistry.h>
 #include <cppunit/ui/text/TestRunner.h>
+
+#include <cstring>
 
 #include "analysis_correlation.hpp"
@@ -116,6 +118,6 @@
   // put pair correlation into bins and check with no range
   binmap = BinData( pointmap, 0.5, 0., 0. );
-  CPPUNIT_ASSERT_EQUAL( (size_t)2, binmap->size() );
-  //OutputCorrelation ( binmap );
+  OutputCorrelation ( (ofstream *)&cout, binmap );
+  CPPUNIT_ASSERT_EQUAL( (size_t)3, binmap->size() );
   tester = binmap->begin();
   CPPUNIT_ASSERT_EQUAL( 1., tester->first );
@@ -129,6 +131,6 @@
   // ... and check with [0., 2.] range
   binmap = BinData( pointmap, 0.5, 0., 2. );
+  OutputCorrelation ( (ofstream *)&cout, binmap );
   CPPUNIT_ASSERT_EQUAL( (size_t)5, binmap->size() );
-  //OutputCorrelation ( binmap );
   tester = binmap->begin();
   CPPUNIT_ASSERT_EQUAL( 0., tester->first );
Index: src/unittests/AnalysisCorrelationToSurfaceUnitTest.cpp
===================================================================
--- src/unittests/AnalysisCorrelationToSurfaceUnitTest.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/unittests/AnalysisCorrelationToSurfaceUnitTest.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -11,4 +11,6 @@
 #include <cppunit/extensions/TestFactoryRegistry.h>
 #include <cppunit/ui/text/TestRunner.h>
+
+#include <cstring>
 
 #include "analysis_correlation.hpp"
@@ -58,55 +60,55 @@
 
   // construct molecule (tetraeder of hydrogens) base
+  TestSurfaceMolecule = new molecule(tafel);
+  Walker = new atom();
+  Walker->type = hydrogen;
+  Walker->node->Init(1., 0., 1. );
+  TestSurfaceMolecule->AddAtom(Walker);
+  Walker = new atom();
+  Walker->type = hydrogen;
+  Walker->node->Init(0., 1., 1. );
+  TestSurfaceMolecule->AddAtom(Walker);
+  Walker = new atom();
+  Walker->type = hydrogen;
+  Walker->node->Init(1., 1., 0. );
+  TestSurfaceMolecule->AddAtom(Walker);
+  Walker = new atom();
+  Walker->type = hydrogen;
+  Walker->node->Init(0., 0., 0. );
+  TestSurfaceMolecule->AddAtom(Walker);
+
+  // check that TestMolecule was correctly constructed
+  CPPUNIT_ASSERT_EQUAL( TestSurfaceMolecule->AtomCount, 4 );
+
+  TestList = new MoleculeListClass;
+  TestSurfaceMolecule->ActiveFlag = true;
+  TestList->insert(TestSurfaceMolecule);
+
+  // init tesselation and linked cell
+  Surface = new Tesselation;
+  LC = new LinkedCell(TestSurfaceMolecule, 5.);
+  FindNonConvexBorder(TestSurfaceMolecule, Surface, (const LinkedCell *&)LC, 2.5, NULL);
+
+  // add outer atoms
   TestMolecule = new molecule(tafel);
   Walker = new atom();
-  Walker->type = hydrogen;
-  Walker->node->Init(1., 0., 1. );
-  TestMolecule->AddAtom(Walker);
-  Walker = new atom();
-  Walker->type = hydrogen;
-  Walker->node->Init(0., 1., 1. );
-  TestMolecule->AddAtom(Walker);
-  Walker = new atom();
-  Walker->type = hydrogen;
-  Walker->node->Init(1., 1., 0. );
-  TestMolecule->AddAtom(Walker);
-  Walker = new atom();
-  Walker->type = hydrogen;
-  Walker->node->Init(0., 0., 0. );
-  TestMolecule->AddAtom(Walker);
-
-  // check that TestMolecule was correctly constructed
-  CPPUNIT_ASSERT_EQUAL( TestMolecule->AtomCount, 4 );
-
-  TestList = new MoleculeListClass;
+  Walker->type = carbon;
+  Walker->node->Init(4., 0., 4. );
+  TestMolecule->AddAtom(Walker);
+  Walker = new atom();
+  Walker->type = carbon;
+  Walker->node->Init(0., 4., 4. );
+  TestMolecule->AddAtom(Walker);
+  Walker = new atom();
+  Walker->type = carbon;
+  Walker->node->Init(4., 4., 0. );
+  TestMolecule->AddAtom(Walker);
+  // add inner atoms
+  Walker = new atom();
+  Walker->type = carbon;
+  Walker->node->Init(0.5, 0.5, 0.5 );
+  TestMolecule->AddAtom(Walker);
   TestMolecule->ActiveFlag = true;
   TestList->insert(TestMolecule);
-
-  // init tesselation and linked cell
-  Surface = new Tesselation;
-  FindNonConvexBorder(TestMolecule, Surface, (const LinkedCell *&)LC, 2.5, NULL);
-  LC = new LinkedCell(TestMolecule, 5.);
-  CPPUNIT_ASSERT_EQUAL( (size_t)4, Surface->PointsOnBoundary.size() );
-  CPPUNIT_ASSERT_EQUAL( (size_t)6, Surface->LinesOnBoundary.size() );
-  CPPUNIT_ASSERT_EQUAL( (size_t)4, Surface->TrianglesOnBoundary.size() );
-
-  // add outer atoms
-  Walker = new atom();
-  Walker->type = carbon;
-  Walker->node->Init(4., 0., 4. );
-  TestMolecule->AddAtom(Walker);
-  Walker = new atom();
-  Walker->type = carbon;
-  Walker->node->Init(0., 4., 4. );
-  TestMolecule->AddAtom(Walker);
-  Walker = new atom();
-  Walker->type = carbon;
-  Walker->node->Init(4., 4., 0. );
-  TestMolecule->AddAtom(Walker);
-  // add inner atoms
-  Walker = new atom();
-  Walker->type = carbon;
-  Walker->node->Init(0.5, 0.5, 0.5 );
-  TestMolecule->AddAtom(Walker);
 
   // init maps
@@ -134,8 +136,21 @@
 
 
+/** Checks whether setup() does the right thing.
+ */
+void AnalysisCorrelationToSurfaceUnitTest::SurfaceTest()
+{
+  CPPUNIT_ASSERT_EQUAL( 4, TestSurfaceMolecule->AtomCount );
+  CPPUNIT_ASSERT_EQUAL( 4, TestMolecule->AtomCount );
+  CPPUNIT_ASSERT_EQUAL( (size_t)2, TestList->ListOfMolecules.size() );
+  CPPUNIT_ASSERT_EQUAL( (size_t)4, Surface->PointsOnBoundary.size() );
+  CPPUNIT_ASSERT_EQUAL( (size_t)6, Surface->LinesOnBoundary.size() );
+  CPPUNIT_ASSERT_EQUAL( (size_t)4, Surface->TrianglesOnBoundary.size() );
+};
+
 void AnalysisCorrelationToSurfaceUnitTest::CorrelationToSurfaceTest()
 {
   // do the pair correlation
   surfacemap = CorrelationToSurface( TestList, hydrogen, Surface, LC );
+//  OutputCorrelationToSurface ( (ofstream *)&cout, surfacemap );
   CPPUNIT_ASSERT( surfacemap != NULL );
   CPPUNIT_ASSERT_EQUAL( (size_t)4, surfacemap->size() );
@@ -147,7 +162,8 @@
   surfacemap = CorrelationToSurface( TestList, hydrogen, Surface, LC );
   // put pair correlation into bins and check with no range
+//  OutputCorrelationToSurface ( (ofstream *)&cout, surfacemap );
   binmap = BinData( surfacemap, 0.5, 0., 0. );
   CPPUNIT_ASSERT_EQUAL( (size_t)1, binmap->size() );
-  //OutputCorrelation ( binmap );
+  OutputCorrelation ( (ofstream *)&cout, binmap );
   tester = binmap->begin();
   CPPUNIT_ASSERT_EQUAL( 0., tester->first );
@@ -160,8 +176,9 @@
   BinPairMap::iterator tester;
   surfacemap = CorrelationToSurface( TestList, hydrogen, Surface, LC );
+//  OutputCorrelationToSurface ( (ofstream *)&cout, surfacemap );
   // ... and check with [0., 2.] range
   binmap = BinData( surfacemap, 0.5, 0., 2. );
   CPPUNIT_ASSERT_EQUAL( (size_t)5, binmap->size() );
-  //OutputCorrelation ( binmap );
+//  OutputCorrelation ( (ofstream *)&cout, binmap );
   tester = binmap->begin();
   CPPUNIT_ASSERT_EQUAL( 0., tester->first );
@@ -177,14 +194,15 @@
   BinPairMap::iterator tester;
   surfacemap = CorrelationToSurface( TestList, carbon, Surface, LC );
+//  OutputCorrelationToSurface ( (ofstream *)&cout, surfacemap );
   // put pair correlation into bins and check with no range
   binmap = BinData( surfacemap, 0.5, 0., 0. );
-  CPPUNIT_ASSERT_EQUAL( (size_t)2, binmap->size() );
-  OutputCorrelation ( (ofstream *)&cout, binmap );
+  //OutputCorrelation ( (ofstream *)&cout, binmap );
+  CPPUNIT_ASSERT_EQUAL( (size_t)9, binmap->size() );
   // inside point is first and must have negative value
-  tester = binmap->lower_bound(2.95); // start depends on the min value and
+  tester = binmap->lower_bound(4.25-0.5); // start depends on the min value and
   CPPUNIT_ASSERT( tester != binmap->end() );
   CPPUNIT_ASSERT_EQUAL( 3, tester->second );
   // inner point
-  tester = binmap->lower_bound(-0.5);
+  tester = binmap->lower_bound(0.);
   CPPUNIT_ASSERT( tester != binmap->end() );
   CPPUNIT_ASSERT_EQUAL( 1, tester->second );
@@ -195,17 +213,17 @@
   BinPairMap::iterator tester;
   surfacemap = CorrelationToSurface( TestList, carbon, Surface, LC );
+//  OutputCorrelationToSurface ( (ofstream *)&cout, surfacemap );
   // ... and check with [0., 2.] range
   binmap = BinData( surfacemap, 0.5, -2., 4. );
+  //OutputCorrelation ( (ofstream *)&cout, binmap );
   CPPUNIT_ASSERT_EQUAL( (size_t)13, binmap->size() );
-  OutputCorrelation ( (ofstream *)&cout, binmap );
   // three outside points
-  tester = binmap->lower_bound(3.);
+  tester = binmap->lower_bound(4.25-0.5);
   CPPUNIT_ASSERT( tester != binmap->end() );
   CPPUNIT_ASSERT_EQUAL( 3, tester->second );
   // inner point
-  tester = binmap->lower_bound(-0.5);
+  tester = binmap->lower_bound(0.);
   CPPUNIT_ASSERT( tester != binmap->end() );
   CPPUNIT_ASSERT_EQUAL( 1, tester->second );
-
 };
 
Index: src/unittests/AnalysisCorrelationToSurfaceUnitTest.hpp
===================================================================
--- src/unittests/AnalysisCorrelationToSurfaceUnitTest.hpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/unittests/AnalysisCorrelationToSurfaceUnitTest.hpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -23,4 +23,5 @@
 {
     CPPUNIT_TEST_SUITE( AnalysisCorrelationToSurfaceUnitTest ) ;
+    CPPUNIT_TEST ( SurfaceTest );
     CPPUNIT_TEST ( CorrelationToSurfaceTest );
     CPPUNIT_TEST ( CorrelationToSurfaceHydrogenBinNoRangeTest );
@@ -33,4 +34,5 @@
       void setUp();
       void tearDown();
+      void SurfaceTest();
       void CorrelationToSurfaceTest();
       void CorrelationToSurfaceHydrogenBinNoRangeTest();
@@ -43,4 +45,5 @@
       MoleculeListClass *TestList;
       molecule *TestMolecule;
+      molecule *TestSurfaceMolecule;
       element *hydrogen;
       element *carbon;
Index: src/unittests/AnalysisPairCorrelationUnitTest.cpp
===================================================================
--- src/unittests/AnalysisPairCorrelationUnitTest.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/unittests/AnalysisPairCorrelationUnitTest.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -11,4 +11,6 @@
 #include <cppunit/extensions/TestFactoryRegistry.h>
 #include <cppunit/ui/text/TestRunner.h>
+
+#include <cstring>
 
 #include "analysis_correlation.hpp"
